function labels = binarize_labels(labels,trueLabel)
%
% This function makes an original, possibly a multi-class label vector 
% binary.
%
% Inputs: 
%
% labels - original label vector
% trueLabel - category of interest
%
% Outputs:
%
% labels - a binary label vector, where category of interest corresponds 
% to 1 and all other categories correspond to 0.

labelsT = zeros(size(labels));
labelsT(labels == trueLabel) = 1;
labelsT(labels ~= trueLabel) = 0;
labels = labelsT;
