function data = compute_grad_norm(data,crit)

if nargin == 1
    crit = 'max';
end

%grad1 = data(1:3:end,:);
%grad2 = data(2:3:end,:);
%Lno = sqrt(grad1.^2 + grad2.^2);
%data(1:3:end,:) = Lno;
%data(2:3:end,:) = Lno;

grad1 = data(1:2:end,:);
grad2 = data(2:2:end,:);

switch crit
    case 'mag'
        Lno = sqrt(grad1.^2 + grad2.^2);
    case 'mean'
        Lno = (grad1 + grad2)/2;
    case 'max'
        Lno = max(grad1,grad2);
    otherwise('Criterion to combine gradient data must be "mag", "mean", or "max"!')
end
data(1:2:end,:) = Lno;
data(2:2:end,:) = Lno;

