function dmat = compute_spatial_dist(A1,A2,lambda)

xx = 1:102;
ord = length(xx);
max_inds1 = NaN*zeros(size(A1,2),ord);
max_inds2 = NaN*zeros(size(A2,2),ord);
An1 = A1;
An2 = A2;
for m = 1:size(A1,2)
    for n = 1:ord
        M = An1';
        M = sqrt(abs(M(m,1:2:end)).^2 + abs(M(m,2:2:end)).^2);
        [ma,mai] = max(M);
        ind = 2*mai - 1;
        An1(ind,m) = NaN;
        max_inds1(m,n) = mai;
    end
end
for m = 1:size(A2,2)
    for n = 1:ord
        M = An2';
        M = sqrt(abs(M(m,1:2:end)).^2 + abs(M(m,2:2:end)).^2);
        [ma,mai] = max(M);
        ind = 2*mai - 1;
        An2(ind,m) = NaN;
        max_inds2(m,n) = mai;
    end
end

An1(~isnan(An1)) = 0;
An1(isnan(An1)) = 1;
An2(~isnan(An2)) = 0;
An2(isnan(An2)) = 1;

if lambda >= 1
    ord = lambda;
end
D = load('NM306coildef');
dmat = zeros(size(A1,2),size(A2,2));
for m = 1:size(An1,2)
%    disp(['find spatial distances, component ' num2str(m) '/' num2str(size(An1,2))])
    for n = 1:size(An2,2)
        for r = 1:ord
            val = norm(D.VM(max_inds1(m,r),:) - D.VM(max_inds2(n,r),:));
            if lambda >= 1 % rectangular decay function
                C = r <= lambda;
            else % exponential decay function
                C = exp(-lambda*(xx(r)-1));
            end
            dmat(m,n) = dmat(m,n) + C*val;
        end
    end
end
