function features = extract_TF_features(D,UU,VV,style)

if strcmp(style,'spatiotemporalLDA') | strcmp(style,'spatiotemporalRLDA') | strcmp(style,'spatiotemporalLDAfull')
    data = permute(D,[3 2 1]);
    p = size(data,1);
    n = size(data,2);
    c = size(data,3);
    
    % project for temporal dimension:
    V = ones(1,size(VV{1},2),size(VV{1},1));
    V(1,:,:) = VV{1}';
    
    nrFeatures = size(V,1); % number of estimated directions
    dataProj = zeros(nrFeatures,c,n);
    features = [];
    iter = 1;
    for m = 1:nrFeatures
        for k = 1:c
            w = squeeze(V(m,:,k));
            if sum(w) == 0
                w = randn(size(w));
            end
            w = w/norm(w);
            w = w(:);
            X = data(:,:,k)';
            Y = X*w;
            dataProj(m,k,:) = Y;
        end
    end
    features = tensor_to_matrix(dataProj);
    % Repeat for spatial dimension:

    U = ones(1,size(UU{1},2),size(UU{1},1));
    U(1,:,:) = UU{1}';
    nrFeatures = size(U,1); % number of estimated directions
    dataProj = zeros(nrFeatures,p,n);
    features2 = [];
    iter = 1;
    for m = 1:nrFeatures
        for k = 1:p
            w = squeeze(U(m,:,k));
            if sum(w) == 0
                w = randn(size(w));
            end
            w = w/norm(w);
            w = w(:);
            X = squeeze(data(k,:,:));
            Y = X*w;
            dataProj(m,k,:) = Y;
        end
    end
    features2 = tensor_to_matrix(dataProj);        
    features = [features features2];
    
else    
    features = [];
    for m = 1:length(D)
        data = permute(D{m},[1 3 2]);
        da = zeros(size(UU{m},2),size(data,2))';
        for n = 1:size(data,2)
            Dat = squeeze(data(:,n,:));
            da(n,:) = diag(UU{m}'*Dat*VV{m});
        end
        features = [features da];
    end
    
end