function [epochs_b,epochs_b_full] = remove_baseline(epochs,baselines)

epochs_b = zeros(size(epochs));
epochs_b_full = zeros(size(epochs,1),size(epochs,2)+size(baselines,2),size(epochs,3));
me = squeeze( mean(baselines,2) );
for m = 1:size(epochs,1)
   epoch_m = squeeze(epochs(m,:,:));
   Baseline_m = repmat(me(m,:),size(epochs,2),1);
   epochs_b(m,:,:) = epoch_m - Baseline_m;
      
   baseline_m = squeeze(baselines(m,:,:));
   Baseline_full_m = repmat(me(m,:),size(epochs_b_full,2),1);
   epochs_b_full(m,:,:) = [baseline_m;epoch_m] - Baseline_full_m;

end
rp1 = randperm(size(epochs,1));
rp2 = randperm(size(epochs,3));

figure
for m = 1:16
    subplot(4,4,m)
    hold on;
    plot((-size(baselines,2)+1):size(epochs,2),squeeze(epochs_b_full(rp1(m),:,rp2(m))),'r')
    plot(1:size(epochs,2),squeeze(epochs(rp1(m),:,rp2(m))),'k--');
    grid on
    title(['Epoch ' num2str(rp1(m)) ', channel ' num2str(rp2(m))])
    xlim([(-size(baselines,2)+1) size(epochs,2)])
end

