function ResFileName = returnResultFileName(Params,...
    spectralModel,rankModel,sparseDA,temporalModel,...
    timeresolvedModel,channelwiseTimeresolvedModel,connectivityModel)

decodingParams = Params.decodingParams;
generalParams = Params.generalParams;

nrIC = decodingParams.nrICs;
ica_on = decodingParams.ica_on;
classifiername = decodingParams.classifiername;

classifierIndex = decodingParams.classifierIndex;

shuf = generalParams.randomize;
sh_id = generalParams.randomizeIndex;

subwinlenSamp = decodingParams.subwinlenSamp;
multiclass = decodingParams.multiclass;
noscaling = decodingParams.skipscaling;
CVfisher = decodingParams.CVfisher;
modelRank = decodingParams.modelRank;
minfreq = decodingParams.minfreq;
maxfreq = decodingParams.maxfreq;
%classif = decodingParams.classifier;
samplingfac = decodingParams.samplingfactor;

if spectralModel
    ResFileName = [classifiername 'rnd' num2str(shuf) 'id' num2str(sh_id) ...
        'ICs' num2str(nrIC) 'mc' num2str(multiclass) 'sc' num2str(noscaling) ... 
        'minfr' num2str(minfreq) 'maxfr' num2str(maxfreq) '.mat'];
end

if timeresolvedModel | temporalModel
    ResFileName = [classifiername 'rnd' num2str(shuf) 'id' num2str(sh_id) ...
        'ICs' num2str(nrIC) 'swl' num2str(subwinlenSamp) 'mc' num2str(multiclass) 'sc' ...
        num2str(noscaling) 'timeind' num2str(classifierIndex) '.mat'];
end

if channelwiseTimeresolvedModel
    winlen_channelwisetimeresolved_samples = decodingParams.winlen_channelwisetimeresolved_samples;
    winstep_channelwisetimeresolved_samples = decodingParams.winstep_channelwisetimeresolved_samples;

    ResFileName = [classifiername 'rnd' num2str(shuf) 'id' ... 
        num2str(sh_id) 'ICs' num2str(nrIC) 'mc' num2str(multiclass) ...
        'sc' num2str(noscaling) 'win' num2str(winlen_channelwisetimeresolved_samples) ...
        'step' num2str(winstep_channelwisetimeresolved_samples) 'timeind' num2str(classifierIndex) '.mat'];    
end

if rankModel
    ResFileName = [ResFileName(1:end-4) 'ra' num2str(modelRank) '.mat'];
end

if sparseDA
    ResFileName = [ResFileName(1:end-4) 'fis' num2str(CVfisher) '.mat'];
end

%ResFileName = [ResFileName(1:end-4) classif '.mat'];
ResFileName = [ResFileName(1:end-4) 'sf' num2str(samplingfac) '.mat'];    

switch ica_on
    case -1
        ResFileName = [ResFileName(1:end-4) 'PCA' '.mat'];
    case 0
        ResFileName = [ResFileName(1:end-4) 'sen' '.mat'];        
    case 1
        ResFileName = [ResFileName(1:end-4) 'ICA' '.mat'];
end
