function epoch_dir = return_epoch_dir(dataset,Params)

generalParams = Params.generalParams;
epochingParams = Params.epochingParams;

result_dir = generalParams.result_dir;

Fs = epochingParams.Fs;
winlen = epochingParams.winlen;
lowcut = epochingParams.lowcut;
highcut = epochingParams.highcut;
order = epochingParams.order;
skipfiltering = epochingParams.skipfiltering;

subject_result_dir = [result_dir 'dataset' num2str(dataset) '/'];

if skipfiltering
    epoch_dir = [subject_result_dir 'epochs' 'Fs' num2str(Fs) 'winlen' num2str(1000*winlen)];
else % add filtering params (Low-cut, High-cut, filter order)
    epoch_dir = [subject_result_dir 'epochs' 'Fs' num2str(Fs) ...
        'winlen' num2str(1000*winlen) 'Low' num2str(lowcut) 'High' ...
        num2str(highcut) 'order' num2str(order)];
end
if epochingParams.use_grad == 0
    epoch_dir = [epoch_dir 'magn'];
elseif epochingParams.use_grad == 1
    epoch_dir = [epoch_dir 'grad'];
elseif epochingParams.use_grad == 2
    epoch_dir = [epoch_dir 'comb'];
else
  error('"use_grad" must be 0,1, or 2!')
end

epoch_dir = [epoch_dir '/'];

