function [fn,classNames,delays] = return_input_filename(dataset)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MEG STUDY PASSIVE DATA: dataset index: 1....99
for m = 1:50
    if m < 10
        fn{m} = ['TD0' num2str(m) '/TD0' num2str(m) '_mov_otp_tsss_mc_ica.fif']; 
    else
        fn{m} = ['TD' num2str(m) '/TD' num2str(m) '_mov_otp_tsss_mc_ica.fif'];            
    end    
end

su_ind = 101;
for m = 1:9
    fn{su_ind} = ['AD0' num2str(m) '/AD0' num2str(m) '_4x_mov_tact_otp_tsss_mc_ica.fif'];
    su_ind = su_ind + 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INTEROCEPTION STUDY MEG DATA: dataset index: 201....300
filen{1} = 'IC_K0014_mc';
filen{2} = 'IC_K0016_mc';
filen{3} = 'IC_K0020_mc_cmb';
filen{4} = 'IC_K0022_mc_cmb';
filen{5} = 'IC_K0023_mc_cmb';
filen{6} = 'IC_K0024_mc_cmb';

su_ind = 201;
Sy{1} = 'both';
Sy{2} = 'sync'; 
Sy{3} = 'nonsync';
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{1} '_style1.fif'];
    su_ind = su_ind + 1;
end
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{2} '_style1.fif'];
    su_ind = su_ind + 1;
end
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{3} '_style1.fif'];
    su_ind = su_ind + 1;
end
Sy{1} = 'both'; 
Sy{2} = 'heart'; 
Sy{3} = 'sound';
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{1} '_style2.fif'];
    su_ind = su_ind + 1;
end
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{2} '_style2.fif'];
    su_ind = su_ind + 1;
end
for s = 1:length(filen)
    fn{su_ind} = [filen{s} '_' Sy{3} '_style2.fif'];
    su_ind = su_ind + 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear classNames
if dataset <= 100
    classNames{1} = 'R.IndexFinger';
    classNames{2} = 'L.IndexFinger';
    classNames{3} = 'R.Ankle';
    classNames{4} = 'L.Ankle';
    delays = [52 52 38 38];
elseif ( dataset > 100 & dataset <= 200 )
    classNames{1} = 'D2.Tac';
    classNames{2} = 'D3.Tac';
    classNames{3} = 'D4.Tac';
    classNames{4} = 'D5.Tac';
    classNames{5} = 'D2.Mov';
    classNames{6} = 'D3.Mov';
    classNames{7} = 'D4.Mov';
    classNames{8} = 'D5.Mov';
    delays = [30 30 30 30 46 54 58 61];
elseif ( dataset > 200 & dataset <= 300 )
    classNames{1} = 'A';
    classNames{2} = 'B';
    delays = [0 0];
else
    error('Unknown data set!')
end

fn = fn{dataset};
