%Z1 = copularnd('Gaussian',0.3,15)';
%Z2 = copularnd('Gaussian',-0.8,10);
%A = Z2*Z1;
figOn = 1;
T = 4000;
c = 10;
Y = randn(c,T);
v = 1;
y1 = [0.9*sin(2.2*(1:T/2)) 0.9*sin(4.4*(1:T/2))] + v*randn(1,T);
y2 = [0.5*sin(7.4*(1:T/2)) 0.2*sin(2.4*(1:T/2))] + v*randn(1,T);
y3 = [0.2*sin(1.1*(1:T/2)) 1*sin(3.3*(1:T/2))] + v*randn(1,T);
labels = [ones(1,T/2) 2*ones(1,T/2)];
Y([1 3 9],:) = [y1;y2;y3];
Y = Y';

n = 100;
t = T/n;
winstart = 1;
winend = t;
X = [];
Lab = [];
for m = 1:n
    X(m,:,:) = Y(winstart:winend,:);
    Lab(m) = labels(winstart);
    winstart = winstart + t;
    winend = winend + t;
end
rp = randperm(size(X,1));
X = X(rp,:,:);
Lab = Lab(rp);

maxRank = 5;
nrFolds = 10;
nr_lambda = 10;

[DataCV,BL] = divide_data_into_blocks(X,Lab,nrFolds,'bilinear');
results_full = [];
results_mean = [];
for m = 1:nrFolds
    disp(['Fold: ' num2str(m) '/' num2str(nrFolds)])
    Xtrain = DataCV.data{m,1};
    Xtest = DataCV.data{m,2};
    labels_train = DataCV.labels{m,1};
    labels_test = DataCV.labels{m,2};
    
    M1 = squeeze(mean(Xtrain(labels_train==1,:,:),1));
    M2 = squeeze(mean(Xtrain(labels_train==2,:,:),1));
    A = M1 - M2;
    lambdas = linspace(1,sqrt(size(A,2)),nr_lambda);    
    [U,V,S,spars_lev] = sparseSVDestimCVFisher(A,maxRank,lambdas);
    % for each test sample, lambda value and factor, perform classification:
    for c = 1:length(lambdas)
        for k = 1:size(U{1},2) % each factor
            proj_mean1 = U{c}(:,k)'*M1*V{c}(:,k);
            proj_mean2 = U{c}(:,k)'*M2*V{c}(:,k);
            for n = 1:size(Xtest,1) % each data point
                Xt = squeeze(Xtest(n,:,:));
                proj_val = U{c}(:,k)'*Xt*V{c}(:,k);
                [mi,label_estim] = min(abs([proj_mean1 proj_mean2] - proj_val));
                correct = ( labels_test(n) == label_estim );
                results_full{k}(c,n,m) = correct;
            end
            results_mean{k} = squeeze(mean(results_full{k},2));
        end
    end
end

% find best lambdas for each factor:
acc2 = NaN*zeros(length(results),size(results{1},1));
for k = 1:length(results_mean)
    acc2(k,:) = mean(results_mean{k},2);
end
[ma,mai] = max(acc2,[],2);
Lam = lambdas(mai); % final lambdas for each factor

% Estimate final model:
M1 = squeeze(mean(X(Lab==1,:,:),1));
M2 = squeeze(mean(X(Lab==2,:,:),1));
A = M1 - M2;
[U,V,S,spars_lev] = sparseSVDestimCVFisher(A,maxRank,Lam,'final');

if figOn
mark{1} = 'rx-';
mark{2} = 'gx-';
mark{3} = 'bx-';
mark{4} = 'cx-';
mark{5} = 'mx-';
figure
for k = 1:size(acc,1)
    plot(lambdas,acc2(k,:),mark{k});clear L;hold on;
end
for m = 1:length(ma)
    plot(lambdas(mai(m)),ma(m),'o','MarkerFaceColor',mark{m}(1),'MarkerEdgeColor','k','MarkerSize',8)
end
for m = 1:size(acc,1)
    L{m} = ['factor ' num2str(m)];
end
legend(L)
xlabel('Hyperparameter Lambda')
ylabel('validation accuracy')
ylim([0.3 1]);grid on
end
% [U_final,S_final,V_final,U2,S2,V2,spars_lev_final] = sparseSVDestim4(A,c_final,rankMax);
