function Params = update_directory_names(Params)

% create names for epoch directories:
for dataset = 1:length(Params.generalParams.nrSubjects)
    epoch_dirs{dataset} = return_epoch_dir(dataset,Params);
end
Params.privateParams.epoch_dirs = epoch_dirs;

% return information regarding the chosen classifier:
[rankModel,spectralModel,temporalModel,timeresolvedModel,...
    channelwiseTimeresolvedModel,sparseDA,connectivityModel] = return_style_type(Params.decodingParams.classifiername);

% return string of filename for which the results will be saved:
ResFileName = returnResultFileName(Params,spectralModel,rankModel,sparseDA,temporalModel,...
    timeresolvedModel,channelwiseTimeresolvedModel,connectivityModel);
    
Params.privateParams.ResFileName = ResFileName;
Params.privateParams.timeresolvedModel = timeresolvedModel;
Params.privateParams.channelwiseTimeresolvedModel = channelwiseTimeresolvedModel;
Params.privateParams.connectivityModel = connectivityModel;
Params.privateParams.spectralModel = spectralModel;
Params.privateParams.rankModel = rankModel;
Params.privateParams.sparseDA = sparseDA;
Params.privateParams.temporalModel = temporalModel;
